Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2232)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments according to new surface-type structure. Remove usm_wall_heat_flux; 
+! insteat, heat fluxes are directly applied in diffusion_s.
 ! 
 ! Former revisions:
@@ -103,4 +104,7 @@
 !>    reflection step using MPI_Alltoall instead of current MPI_Allgather.
 !>
+!> 3. Temporarily large values of surface heat flux can be observed, up to
+!>    1.2 Km/s, which seem to be not realistic.
+!>
 !> @todo Check optimizations for RMA operations
 !> @todo Alternatives for MPI_WIN_ALLOCATE? (causes problems with openmpi)
@@ -111,5 +115,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  zu, pt, pt_1, pt_2, p, ol, shf, ts, us, u, v, w, hyp, tend
+        ONLY:  zu, pt, pt_1, pt_2, p, u, v, w, hyp, tend
 
     USE cloud_parameters,                                                      &
@@ -137,5 +141,5 @@
     USE indices,                                                               &
         ONLY:  nx, ny, nnx, nny, nnz, nxl, nxlg, nxr, nxrg, nyn, nyng, nys,    &
-               nysg, nzb_s_inner, nzb_s_outer, nzb, nzt, nbgp
+               nysg, nzb, nzt, nbgp, wall_flags_0
 
     USE, INTRINSIC :: iso_c_binding 
@@ -157,4 +161,6 @@
     USE statistics,                                                            &
         ONLY:  hom, statistic_regions
+
+    USE surface_mod
 
                
@@ -265,4 +271,14 @@
         REAL(wp)                                   :: rtransp           !< 
     END TYPE
+!
+!-- Type for surface temperatures at vertical walls. Is not necessary for horizontal walls. 
+    TYPE t_surf_vertical
+       REAL(wp), DIMENSION(:), ALLOCATABLE         :: t
+    END TYPE t_surf_vertical
+!
+!-- Type for wall temperatures at vertical walls. Is not necessary for horizontal walls. 
+    TYPE t_wall_vertical
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE       :: t
+    END TYPE t_wall_vertical
 
 !-- arrays for calculation of svf and csf
@@ -320,5 +336,5 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfins_av       !< average of array of residua of sw radiation absorbed in surface after last reflection
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinl_av       !< average of array of residua of lw radiation absorbed in surface after last reflection
-    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface    
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfhf_av        !< average of total radiation flux incoming to minus outgoing from local surface  
     
 !-- block variables needed for calculation of the plant canopy model inside the urban surface model
@@ -367,21 +383,24 @@
 !-- surface and material model variables for walls, ground, roofs
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        :: surface_types      !< array of types of wall parameters
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: zwn                !< normalized wall layer depths (m)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: ddz_wall           !< 1/dz_wall
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: ddz_wall_stag      !< 1/dz_wall_stag
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: dz_wall            !< wall grid spacing (center-center)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: dz_wall_stag       !< wall grid spacing (edge-edge) 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: zw                 !< wall layer depths (m)
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf             !< wall surface temperature (K)
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_p           !< progn. wall surface temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h           !< wall surface temperature (K) at horizontal walls
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_p         !< progn. wall surface temperature (K) at horizontal walls
+
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_v
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  ::  t_surf_v_p
 #else
-    REAL(wp), DIMENSION(:), POINTER                :: t_surf
-    REAL(wp), DIMENSION(:), POINTER                :: t_surf_p 
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_1
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_2
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_h
+    REAL(wp), DIMENSION(:), POINTER                :: t_surf_h_p 
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_1
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_h_2
+
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_v_p
+
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_v_1
+    TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_v_2
 #endif
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_av          !< average of wall surface temperature (K)
@@ -394,31 +413,22 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !-- parameters of the land, roof and wall surfaces
-    LOGICAL,  DIMENSION(:), ALLOCATABLE            :: isroof_surf        !< is the surface the part of a roof
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: albedo_surf        !< albedo of the surface
 !-- parameters of the wall surfaces
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: c_surface          !< heat capacity of the wall surface skin ( J mâ2 Kâ1 )
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: emiss_surf         !< emissivity of the wall surface
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: lambda_surf        !< heat conductivity Î»S between air and surface ( W mâ2 Kâ1 )
-    
-!-- parameters of the walls material
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: thickness_wall     !< thickness of the wall, roof and soil layers
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: rho_c_wall         !< volumetric heat capacity of the material ( J m-3 K-1 ) (= 2.19E6)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: lambda_h           !< heat conductivity Î»T of the material ( W m-1 K-1 )
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: roughness_wall     !< roughness relative to concrete
-    
-!-- output wall heat flux arrays
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: wshf               !< kinematic wall heat flux of sensible heat (needed for diffusion_s!<)
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: wshf_eb            !< wall heat flux of sensible heat in wall normal direction
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: wshf_eb_av         !< average of wshf_eb
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: wghf_eb            !< wall ground heat flux
-    REAL(wp), DIMENSION(:), ALLOCATABLE            :: wghf_eb_av         !< average of wghf_eb
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET  :: t_wall             !< Wall temperature (K)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET  :: t_wall_av          !< Average of t_wall
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET  :: t_wall_p           !< Prog. wall temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_wall_h             !< Wall temperature (K)
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_wall_h_av          !< Average of t_wall
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_wall_h_p           !< Prog. wall temperature (K)
+
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v             !< Wall temperature (K)
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_av          !< Average of t_wall
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_p           !< Prog. wall temperature (K)
 #else
-    REAL(wp), DIMENSION(:,:), POINTER              :: t_wall, t_wall_p
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET  :: t_wall_av, t_wall_1, t_wall_2
+    REAL(wp), DIMENSION(:,:), POINTER                :: t_wall_h, t_wall_h_p
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET    :: t_wall_h_av, t_wall_h_1, t_wall_h_2
+
+    TYPE(t_wall_vertical), DIMENSION(:), POINTER   :: t_wall_v, t_wall_v_p
+    TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: t_wall_v_av, t_wall_v_1, t_wall_v_2
 #endif
 
@@ -488,10 +498,5 @@
        MODULE PROCEDURE usm_swap_timelevel
     END INTERFACE usm_swap_timelevel
-    
-    INTERFACE usm_wall_heat_flux
-       MODULE PROCEDURE usm_wall_heat_flux
-       MODULE PROCEDURE usm_wall_heat_flux_ij
-    END INTERFACE usm_wall_heat_flux
-    
+        
     INTERFACE usm_write_restart_data
        MODULE PROCEDURE usm_write_restart_data
@@ -508,5 +513,4 @@
            usm_energy_balance_land, usm_energy_balance_wall, nrefsteps,        &
            usm_init_urban_surface, usm_radiation, usm_read_restart_data,       &
-           usm_wall_heat_flux,                                                 &
            usm_surface_energy_balance, usm_material_heat_model,                &
            usm_swap_timelevel, usm_check_data_output, usm_average_3d_data,     &
@@ -531,7 +535,9 @@
         IMPLICIT NONE
        
-        INTEGER(iwp)                            :: i, j, k, d, l, ir, jr, ids
-        INTEGER(iwp)                            :: nzubl, nzutl, isurf, ipcgb
-        INTEGER(iwp)                            :: procid
+        INTEGER(iwp) :: i, j, k, d, l, ir, jr, ids, m
+        INTEGER(iwp) :: k_topo     !< vertical index indicating topography top for given (j,i)
+        INTEGER(iwp) :: k_topo2    !< vertical index indicating topography top for given (j,i)
+        INTEGER(iwp) :: nzubl, nzutl, isurf, ipcgb
+        INTEGER(iwp) :: procid
 
         
@@ -543,8 +549,24 @@
         CALL location_message( '', .TRUE. )
         CALL location_message( '    allocation of needed arrays', .TRUE. )
-!--     find nzub, nzut, nzu
-        nzubl = minval(nzb_s_inner(nys:nyn,nxl:nxr))
-        nzutl = maxval(nzb_s_inner(nys:nyn,nxl:nxr))
+!
+!--     Find nzub, nzut, nzu via wall_flag_0 array (nzb_s_inner will be 
+!--     removed later). The following contruct finds the lowest / largest index
+!--     for any upward-facing wall (see bit 12). 
+        nzubl = MINVAL(                                                        &
+                    MAXLOC(                                                    &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(:,nys:nyn,nxl:nxr), 12 )  &
+                               ), DIM = 1                                      &
+                          ) - 1                                                & 
+                            )
+        nzutl = MAXVAL(                                                        &
+                   MAXLOC(                                                     &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(:,nys:nyn,nxl:nxr), 12 )  &
+                               ), DIM = 1                                      &
+                          ) - 1                                                &
+                            )
         nzubl = max(nzubl,nzb)
+
         
         IF ( plant_canopy )  THEN
@@ -559,8 +581,14 @@
             DO i = nxl, nxr
                 DO j = nys, nyn
+!
+!--                 Find topography top index
+                    k_topo = MAXLOC( MERGE( 1, 0,                              &
+                                             BTEST( wall_flags_0(:,j,i), 12 )  &
+                                           ), DIM = 1                          &
+                                   ) - 1
                     DO k = nzt+1, 0, -1
                         IF ( lad_s(k,j,i) /= 0.0_wp )  THEN
 !--                         we are at the top of the pcs
-                            pct(j,i) = k + nzb_s_inner(j,i)
+                            pct(j,i) = k + k_topo
                             pch(j,i) = k
                             npcbl = npcbl + pch(j,i)
@@ -601,27 +629,23 @@
         CALL location_message( '    calculation of indices for surfaces', .TRUE. )
         nsurfl = 0
-!--     calculate land surface and roof
-        startland = nsurfl+1
-        nsurfl = nsurfl+(nxr-nxl+1)*(nyn-nys+1)
-        endland = nsurfl
-        nlands = endland-startland+1
-
-!--     calculation of the walls
+!
+!--     Number of land- and roof surfaces. Note, since horizontal surface elements
+!--     are already counted in surface_mod, in case be simply reused here.
+        startland = 1
+        nsurfl    = surf_usm_h%ns
+        endland   = nsurfl
+        nlands    = endland-startland+1
+
+!
+!--     Number of vertical surfaces. As vertical surfaces are already 
+!--     counted in surface mod, it can be reused here. 
         startwall = nsurfl+1
-        DO i = nxl, nxr
-            DO j = nys, nyn
-!--             test for walls
-!--             (we don't use array flags because it isn't calculated in case of masking_method=.T.)
-                DO ids = 1, 4  !-- four wall directions
-                    jr = min(max(j-jdir(ids),0),ny)
-                    ir = min(max(i-idir(ids),0),nx)
-                    nsurfl = nsurfl + max(0, nzb_s_inner(jr,ir)-nzb_s_inner(j,i))
-                ENDDO
-            ENDDO
-        ENDDO
+        nsurfl = nsurfl + surf_usm_v(0)%ns + surf_usm_v(1)%ns +        &
+                          surf_usm_v(2)%ns + surf_usm_v(3)%ns 
         endwall = nsurfl
         nwalls = endwall-startwall+1
-        
-!--     range of energy balance surfaces
+
+        
+!--     range of energy balance surfaces  ! will be treated separately by surf_usm_h and surf_usm_v
         nenergy = 0
         IF ( usm_energy_balance_land )  THEN
@@ -641,5 +665,5 @@
 !--     block of virtual surfaces
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!--     calculate sky surfaces
+!--     calculate sky surfaces  ! not used so far!
         startsky = nsurfl+1
         nsurfl = nsurfl+(nxr-nxl+1)*(nyn-nys+1)
@@ -656,14 +680,24 @@
         ijdb = RESHAPE( (/ nxl,nxr,nyn,nyn,nxl,nxr,nys,nys,nxr,nxr,nys,nyn,nxl,nxl,nys,nyn /), (/4, 4/) )
 !--     calulation of the free borders of the domain
-        DO ids = 6,9
-            IF ( isborder(ids) )  THEN
-!--             free border of the domain in direction ids
-                DO i = ijdb(1,ids), ijdb(2,ids)
-                    DO j = ijdb(3,ids), ijdb(4,ids)
-                        k = nzut - max(nzb_s_inner(j,i), nzb_s_inner(j-jdir(ids),i-idir(ids)))
-                        nsurfl = nsurfl + k
-                    ENDDO
-                ENDDO
-            ENDIF
+        DO  ids = 6,9
+           IF ( isborder(ids) )  THEN
+!--           free border of the domain in direction ids
+              DO  i = ijdb(1,ids), ijdb(2,ids)
+                 DO  j = ijdb(3,ids), ijdb(4,ids)
+
+                    k_topo =   MAXLOC( MERGE( 1, 0,                            &
+                                             BTEST( wall_flags_0(:,j,i), 12 )  &
+                                            ), DIM = 1                         &
+                                     ) - 1
+                    k_topo2 =  MAXLOC( MERGE( 1, 0,                            &
+                                             BTEST( wall_flags_0(:,j-jdir(ids),i-idir(ids)), 12 )  &
+                                            ), DIM = 1                         &
+                                     ) - 1 
+
+                    k = nzut - MAX( k_topo, k_topo2 )
+                    nsurfl = nsurfl + k
+                 ENDDO
+              ENDDO
+           ENDIF
         ENDDO
         
@@ -676,5 +710,11 @@
             DO i = nxl, nxr
                 DO j = nys, nyn
-                    DO k = nzb_s_inner(j,i)+1, pct(j,i)
+!
+!--                 Find topography top index
+                    k_topo = MAXLOC( MERGE( 1, 0,                              &
+                                             BTEST( wall_flags_0(:,j,i), 12 )  &
+                                          ), DIM = 1                           &
+                                   ) - 1
+                    DO k = k_topo + 1, pct(j,i)
                         ipcgb = ipcgb + 1
                         gridpcbl(k,j,i) = ipcgb
@@ -689,5 +729,5 @@
 
 !--     fill surfl
-        ALLOCATE(surfl(4,nsurfl))
+        ALLOCATE(surfl(5,nsurfl))
         isurf = 0
         
@@ -695,7 +735,10 @@
         DO i = nxl, nxr
             DO j = nys, nyn
-                isurf = isurf + 1
-                k = nzb_s_inner(j,i)+1
-                surfl(:,isurf) = (/iroof,k,j,i/)
+               DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+                  k = surf_usm_h%k(m)
+
+                  isurf = isurf + 1
+                  surfl(:,isurf) = (/iroof,k,j,i,m/)
+               ENDDO
             ENDDO
         ENDDO
@@ -704,12 +747,32 @@
         DO i = nxl, nxr
             DO j = nys, nyn
-                DO ids = 1, 4  !> four wall directions
-                    jr = min(max(j-jdir(ids),0),ny)
-                    ir = min(max(i-idir(ids),0),nx)
-                    DO k = nzb_s_inner(j,i)+1, nzb_s_inner(jr,ir)
-                        isurf = isurf + 1
-                        surfl(:,isurf) = (/ids,k,j,i/)
-                    ENDDO
-                ENDDO
+               l = 0
+               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
+                  k = surf_usm_v(l)%k(m)
+
+                  isurf          = isurf + 1
+                  surfl(:,isurf) = (/2,k,j,i,m/)
+               ENDDO
+               l = 1
+               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
+                  k = surf_usm_v(l)%k(m)
+
+                  isurf          = isurf + 1
+                  surfl(:,isurf) = (/1,k,j,i,m/)
+               ENDDO
+               l = 2
+               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
+                  k = surf_usm_v(l)%k(m)
+
+                  isurf          = isurf + 1
+                  surfl(:,isurf) = (/4,k,j,i,m/)
+               ENDDO
+               l = 3
+               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
+                  k = surf_usm_v(l)%k(m)
+
+                  isurf          = isurf + 1
+                  surfl(:,isurf) = (/3,k,j,i,m/)
+               ENDDO
             ENDDO
         ENDDO
@@ -720,5 +783,5 @@
                 isurf = isurf + 1
                 k = nzut
-                surfl(:,isurf) = (/isky,k,j,i/)
+                surfl(:,isurf) = (/isky,k,j,i,-1/)
             ENDDO
         ENDDO
@@ -730,7 +793,15 @@
                 DO i = ijdb(1,ids), ijdb(2,ids)
                     DO j = ijdb(3,ids), ijdb(4,ids)
-                        DO k = max(nzb_s_inner(j,i),nzb_s_inner(j-jdir(ids),i-idir(ids)))+1, nzut
+                        k_topo =   MAXLOC( MERGE( 1, 0,                        &
+                                             BTEST( wall_flags_0(:,j,i), 12 )  &
+                                                ), DIM = 1                     &
+                                         ) - 1
+                        k_topo2 =  MAXLOC( MERGE( 1, 0,                        &
+                                             BTEST( wall_flags_0(:,j-jdir(ids),i-idir(ids)), 12 )  &
+                                                ), DIM = 1                     &
+                                         ) - 1 
+                        DO k = MAX(k_topo,k_topo2)+1, nzut
                             isurf = isurf + 1
-                            surfl(:,isurf) = (/ids,k,j,i/)
+                            surfl(:,isurf) = (/ids,k,j,i,-1/)
                         ENDDO
                     ENDDO
@@ -755,8 +826,8 @@
         surfstart(numprocs) = k
         nsurf = k
-        ALLOCATE(surf(4,nsurf))
+        ALLOCATE(surf(5,nsurf))
         
 #if defined( __parallel )
-        CALL MPI_AllGatherv(surfl, nsurfl*4, MPI_INTEGER, surf, nsurfs*4, surfstart*4, MPI_INTEGER, comm2d, ierr)
+        CALL MPI_AllGatherv(surfl, nsurfl*5, MPI_INTEGER, surf, nsurfs*5, surfstart*5, MPI_INTEGER, comm2d, ierr)
 #else
         surf = surfl
@@ -787,6 +858,28 @@
         ALLOCATE( surfouts(nsurf) ) !TODO: global surfaces without virtual
         ALLOCATE( surfoutl(nsurf) ) !TODO: global surfaces without virtual
-        ALLOCATE( surfhf(startenergy:endenergy) )
-        ALLOCATE( rad_net_l(startenergy:endenergy) )
+
+
+
+!
+!--     Allocate radiation arrays which are part of the new data type. 
+!--     For horizontal surfaces.
+        ALLOCATE( surf_usm_h%surfhf(1:surf_usm_h%ns)    )
+        ALLOCATE( surf_usm_h%rad_net_l(1:surf_usm_h%ns) )
+!
+!--  New
+        ALLOCATE( surf_usm_h%rad_in_sw(1:surf_usm_h%ns)  )
+        ALLOCATE( surf_usm_h%rad_out_sw(1:surf_usm_h%ns) )
+        ALLOCATE( surf_usm_h%rad_in_lw(1:surf_usm_h%ns)  )
+        ALLOCATE( surf_usm_h%rad_out_lw(1:surf_usm_h%ns) )
+!
+!--     For vertical surfaces
+        DO  l = 0, 3
+           ALLOCATE( surf_usm_v(l)%surfhf(1:surf_usm_v(l)%ns)    )
+           ALLOCATE( surf_usm_v(l)%rad_net_l(1:surf_usm_v(l)%ns) )
+           ALLOCATE( surf_usm_v(l)%rad_in_sw(1:surf_usm_v(l)%ns)  )
+           ALLOCATE( surf_usm_v(l)%rad_out_sw(1:surf_usm_v(l)%ns) )
+           ALLOCATE( surf_usm_v(l)%rad_in_lw(1:surf_usm_v(l)%ns)  )
+           ALLOCATE( surf_usm_v(l)%rad_out_lw(1:surf_usm_v(l)%ns) )
+        ENDDO
 
 !--     Wall surface model
@@ -794,5 +887,8 @@
        
 !--     allocate array of wall types and wall parameters
-        ALLOCATE ( surface_types(startenergy:endenergy) )
+        ALLOCATE ( surf_usm_h%surface_types(1:surf_usm_h%ns) )
+        DO  l = 0, 3
+           ALLOCATE( surf_usm_v(l)%surface_types(1:surf_usm_v(l)%ns) )
+        ENDDO
        
 !--     broadband albedo of the land, roof and wall surface
@@ -802,58 +898,131 @@
         ALLOCATE ( albedo_surf(nsurfl) )
         albedo_surf = 1.0_wp
+        ALLOCATE ( surf_usm_h%albedo_surf(1:surf_usm_h%ns) )
+        DO  l = 0, 3
+           ALLOCATE( surf_usm_v(l)%albedo_surf(1:surf_usm_v(l)%ns) )
+        ENDDO
        
-!--     wall and roof surface parameters
-        ALLOCATE ( isroof_surf(startenergy:endenergy) )
+!--     wall and roof surface parameters. First for horizontal surfaces
         ALLOCATE ( emiss_surf(startenergy:endenergy) )
-        ALLOCATE ( lambda_surf(startenergy:endenergy) )
-        ALLOCATE ( c_surface(startenergy:endenergy) )
-        ALLOCATE ( roughness_wall(startenergy:endenergy) )
+
+        ALLOCATE ( surf_usm_h%isroof_surf(1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%emiss_surf(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%lambda_surf(1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%c_surface(1:surf_usm_h%ns)      )
+        ALLOCATE ( surf_usm_h%roughness_wall(1:surf_usm_h%ns) )
+!
+!--     For vertical surfaces.
+        DO  l = 0, 3
+           ALLOCATE ( surf_usm_v(l)%emiss_surf(1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%lambda_surf(1:surf_usm_v(l)%ns)    )
+           ALLOCATE ( surf_usm_v(l)%c_surface(1:surf_usm_v(l)%ns)      )
+           ALLOCATE ( surf_usm_v(l)%roughness_wall(1:surf_usm_v(l)%ns) )
+        ENDDO
        
-!--     allocate wall and roof material parameters
-        ALLOCATE ( thickness_wall(startenergy:endenergy) )
-        ALLOCATE ( lambda_h(nzb_wall:nzt_wall,startenergy:endenergy) )
-        ALLOCATE ( rho_c_wall(nzb_wall:nzt_wall,startenergy:endenergy) )
-
-!--     allocate wall and roof layers sizes
+!--     allocate wall and roof material parameters. First for horizontal surfaces
+        ALLOCATE ( surf_usm_h%thickness_wall(1:surf_usm_h%ns)               )
+        ALLOCATE ( surf_usm_h%lambda_h(nzb_wall:nzt_wall,1:surf_usm_h%ns)   )
+        ALLOCATE ( surf_usm_h%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
+!
+!--     For vertical surfaces.
+        DO  l = 0, 3
+           ALLOCATE ( surf_usm_v(l)%thickness_wall(1:surf_usm_v(l)%ns)               )
+           ALLOCATE ( surf_usm_v(l)%lambda_h(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)   )
+           ALLOCATE ( surf_usm_v(l)%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
+        ENDDO
+
+!--     allocate wall and roof layers sizes. For horizontal surfaces.
         ALLOCATE ( zwn(nzb_wall:nzt_wall) )
-        ALLOCATE ( dz_wall(nzb_wall:nzt_wall+1, startenergy:endenergy) )
-        ALLOCATE ( ddz_wall(nzb_wall:nzt_wall+1, startenergy:endenergy) )
-        ALLOCATE ( dz_wall_stag(nzb_wall:nzt_wall, startenergy:endenergy) )
-        ALLOCATE ( ddz_wall_stag(nzb_wall:nzt_wall, startenergy:endenergy) )
-        ALLOCATE ( zw(nzb_wall:nzt_wall, startenergy:endenergy) )
-
-!--     allocate wall and roof temperature arrays
+        ALLOCATE ( surf_usm_h%dz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%ddz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%dz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
+        ALLOCATE ( surf_usm_h%ddz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%zw(nzb_wall:nzt_wall,1:surf_usm_h%ns)            )
+!
+!--     For vertical surfaces.
+        DO  l = 0, 3
+           ALLOCATE ( surf_usm_v(l)%dz_wall(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%ddz_wall(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)    )
+           ALLOCATE ( surf_usm_v(l)%dz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)  )
+           ALLOCATE ( surf_usm_v(l)%ddz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%zw(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)            )
+        ENDDO
+
+!--     allocate wall and roof temperature arrays, for horizontal walls
 #if defined( __nopointer )
-        ALLOCATE ( t_surf(startenergy:endenergy) )
-        ALLOCATE ( t_surf_p(startenergy:endenergy) )
-        ALLOCATE ( t_wall(nzb_wall:nzt_wall+1,startenergy:endenergy) )
-        ALLOCATE ( t_wall_p(nzb_wall:nzt_wall+1,startenergy:endenergy) )
+        ALLOCATE ( t_surf_h(1:surf_usm_h%ns) )
+        ALLOCATE ( t_surf_h_p(1:surf_usm_h%ns) )
+        ALLOCATE ( t_wall_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        ALLOCATE ( t_wall_h_p(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+
+        ALLOCATE ( t_surf_h(1:surf_usm_h%ns) )
+        ALLOCATE ( t_surf_h_p(1:surf_usm_h%ns) )
+        ALLOCATE ( t_wall_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        ALLOCATE ( t_wall_h_p(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
 #else
-        ALLOCATE ( t_surf_1(startenergy:endenergy) )
-        ALLOCATE ( t_surf_2(startenergy:endenergy) )
-        ALLOCATE ( t_wall_1(nzb_wall:nzt_wall+1,startenergy:endenergy) )
-        ALLOCATE ( t_wall_2(nzb_wall:nzt_wall+1,startenergy:endenergy) )
+        ALLOCATE ( t_surf_h_1(1:surf_usm_h%ns) )
+        ALLOCATE ( t_surf_h_2(1:surf_usm_h%ns) )
+        ALLOCATE ( t_wall_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+        ALLOCATE ( t_wall_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
 
 !--     initial assignment of the pointers
-        t_wall    => t_wall_1;    t_wall_p    => t_wall_2
-        t_surf => t_surf_1; t_surf_p => t_surf_2
+        t_wall_h    => t_wall_h_1;    t_wall_h_p    => t_wall_h_2
+        t_surf_h => t_surf_h_1; t_surf_h_p => t_surf_h_2
 #endif
 
-!--     allocate intermediate timestep arrays
-        ALLOCATE ( tt_surface_m(startenergy:endenergy) )
-        ALLOCATE ( tt_wall_m(nzb_wall:nzt_wall+1,startenergy:endenergy) )
-
-!--     allocate wall heat flux output array
-        ALLOCATE ( wshf(startwall:endwall) )
-        ALLOCATE ( wshf_eb(startenergy:endenergy) )
-        ALLOCATE ( wghf_eb(startenergy:endenergy) )
-
-!--     set inital values for prognostic quantities
-        tt_surface_m = 0.0_wp
-        tt_wall_m    = 0.0_wp
-
-        wshf = 0.0_wp
-        wshf_eb = 0.0_wp
-        wghf_eb = 0.0_wp
+!--     allocate wall and roof temperature arrays, for vertical walls
+#if defined( __nopointer )
+        DO  l = 0, 3
+           ALLOCATE ( t_surf_v(l)%t(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( t_surf_v(l)%t_p(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( t_wall_v(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           ALLOCATE ( t_wall_v(l)%t_p(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+        ENDDO
+#else
+        DO  l = 0, 3
+           ALLOCATE ( t_surf_v_1(l)%t(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( t_surf_v_2(l)%t(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( t_wall_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           ALLOCATE ( t_wall_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+        ENDDO
+!
+!--     initial assignment of the pointers
+        t_wall_v    => t_wall_v_1;    t_wall_v_p    => t_wall_v_2
+        t_surf_v => t_surf_v_1; t_surf_v_p => t_surf_v_2
+#endif
+!
+!--     Allocate intermediate timestep arrays. For horizontal surfaces.
+        ALLOCATE ( surf_usm_h%tt_surface_m(1:surf_usm_h%ns)                  )
+        ALLOCATE ( surf_usm_h%tt_wall_m(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )
+!
+!--     Set inital values for prognostic quantities
+        IF ( ALLOCATED( surf_usm_h%tt_surface_m ) )  surf_usm_h%tt_surface_m = 0.0_wp
+        IF ( ALLOCATED( surf_usm_h%tt_wall_m    ) )  surf_usm_h%tt_wall_m    = 0.0_wp
+!
+!--     Now, for vertical surfaces
+        DO  l = 0, 3
+           ALLOCATE ( surf_usm_v(l)%tt_surface_m(1:surf_usm_v(l)%ns)                  )
+           ALLOCATE ( surf_usm_v(l)%tt_wall_m(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           IF ( ALLOCATED( surf_usm_v(l)%tt_surface_m ) )  surf_usm_v(l)%tt_surface_m = 0.0_wp
+           IF ( ALLOCATED( surf_usm_v(l)%tt_wall_m    ) )  surf_usm_v(l)%tt_wall_m    = 0.0_wp
+        ENDDO
+
+!--     allocate wall heat flux output array and set initial values. For horizontal surfaces
+!         ALLOCATE ( surf_usm_h%wshf(1:surf_usm_h%ns)    )  !can be removed 
+        ALLOCATE ( surf_usm_h%wshf_eb(1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%wghf_eb(1:surf_usm_h%ns) )
+        IF ( ALLOCATED( surf_usm_h%wshf    ) )  surf_usm_h%wshf    = 0.0_wp
+        IF ( ALLOCATED( surf_usm_h%wshf_eb ) )  surf_usm_h%wshf_eb = 0.0_wp
+        IF ( ALLOCATED( surf_usm_h%wghf_eb ) )  surf_usm_h%wghf_eb = 0.0_wp
+!
+!--     Now, for vertical surfaces
+        DO  l = 0, 3
+!            ALLOCATE ( surf_usm_v(l)%wshf(1:surf_usm_v(l)%ns)    )    ! can be removed
+           ALLOCATE ( surf_usm_v(l)%wshf_eb(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%wghf_eb(1:surf_usm_v(l)%ns) )
+           IF ( ALLOCATED( surf_usm_v(l)%wshf    ) )  surf_usm_v(l)%wshf    = 0.0_wp
+           IF ( ALLOCATED( surf_usm_v(l)%wshf_eb ) )  surf_usm_v(l)%wshf_eb = 0.0_wp
+           IF ( ALLOCATED( surf_usm_v(l)%wghf_eb ) )  surf_usm_v(l)%wghf_eb = 0.0_wp
+        ENDDO
         
     END SUBROUTINE usm_allocate_urban_surface
@@ -874,5 +1043,5 @@
         CHARACTER (len=*), INTENT(IN) :: variable
   
-        INTEGER(iwp)                                       :: i, j, k, l, ids, iwl,istat
+        INTEGER(iwp)                                       :: i, j, k, l, m, ids, iwl,istat
         CHARACTER (len=varnamelength)                      :: var, surfid
         INTEGER(iwp), PARAMETER                            :: nd = 5
